//module msgsocket.h
// Private Copyright Dr.E.Huckert 10-1998
#ifndef MSGSOCKET_DEFINED
#define MSGSOCKET_DEFINED

// versions
//   2003-05-01 added set_content_length()
//              added is_binary()

class MSGSOCKET
{
private:
  char operation;
  long lcontent;
  int  binary;
  char *content;
public:
  MSGSOCKET(char op, char *con, long lcon);
  MSGSOCKET(char op, char *con);
  ~MSGSOCKET();
  char get_operation()
  { 
    return this->operation; 
  };
  char *get_content()
  {
    return this->content;
  }
  long get_content_length()
  {
    return lcontent;
  };
  long get_message_length()
  {
    return lcontent + sizeof(operation);
  };
  void set_content_length(long len)
  {
    this->lcontent = len;
  };
  int is_binary()
  {
    return binary;
  };
  int parse_and_fill(char *src, long lsrc);
  char *flatten();
  int  get_field(char *src, int fieldno, char *dest, int ldest, char sep);
};
#endif

